using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.IO;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace csavi {
    public partial class MainForm : Form {
        //}EX
        struct MouseHistory {
            public MouseButtons button;
            public int x, y;
            public Color col;
            public TimeSpan time;
        };

        enum RecordingStatus {
            STOP, WAIT_START, RECORDING, PROCESSING,
        };

        RecordingStatus Recording = RecordingStatus.STOP;
        DateTime StartTime;
        List<MouseHistory> mouse_list = new List<MouseHistory>();
        Bitmap bb_bmp;
        Graphics bb_g;

        //^֘Ȁ
        const int RECORD_TIME = 8;
        const int FRAMERATE = 24;
        const int CANVAS_WIDTH = 320;
        const int CANVAS_HEIGHT = 240;


        public MainForm() {
            InitializeComponent();
        }


        void InitializeRecord() {
            //^掞
            mouse_list.Clear();
            bb_g.Clear(Color.White);
            picCanvas.CreateGraphics().Clear(Color.White);

            Recording = RecordingStatus.RECORDING;
            cmdStart.Text = "^撆c";
            cmdStart.Enabled = false;
            StartTime = DateTime.Now;
            timer1.Enabled = true;
            toolStripProgressBar1.Value = 0;
        }

        //dȂt@C𐶐
        string GenerateUniqueFilename() {
            string s;
            int i;

            for (i = 0; i < 100; i++) {
                s = String.Format("tmp{0:00}.avi", i);
                if (!File.Exists(s))
                    return s;
            }
            return "";

        }

        //AVIt@Cۑ
        void SaveMovie() {
            string FileName = GenerateUniqueFilename();

            if (FileName == "") {
                MessageBox.Show("avit@Cʂɂ邽߁Aۑ𒆎~܂B");
                return;
            }

            //AVIt@CJn
            AVIManager am = new AVIManager();
            am.OpenFile(FileName, FRAMERATE, CANVAS_WIDTH, CANVAS_HEIGHT);

            //܂G쐬
            am.Graphic.Clear(Color.White);
            int mh_index = 0, frame;

            //1R}쐬
            for (frame = 0; frame <= FRAMERATE * RECORD_TIME; frame++) {
                TimeSpan ts = new TimeSpan(0, 0, 0, frame / FRAMERATE, (frame % FRAMERATE) * 1000 / FRAMERATE);

                //̎Ԃ܂ł̃Cxg`
                while (mh_index < mouse_list.Count && mouse_list[mh_index].time < ts) {
                    DrawPreview(mouse_list[mh_index], am.Graphic);
                    mh_index++;
                }

                //摜ǉ
                am.AddVideoFrame();

                //XV
                if (frame % FRAMERATE == FRAMERATE - 1) {
                    cmdStart.Text = String.Format("摜ۑcF{0}bI", (frame + 1) / FRAMERATE);
                    Application.DoEvents();
                }
            }

            //쐬
            short[] buffer = new short[44100 * 2];
            float phase = 0, delta_phase = 1.0f / 440;
            int vol = 0;
            MouseButtons mb = 0;

            mh_index = 0;

            for (frame = 0; frame < 44100 * RECORD_TIME; frame++) {
                int pos = (frame % 44100) * 2;
                buffer[pos]=0;

                //̎Ԃ܂ł̃CxgvZ
                TimeSpan ts = new TimeSpan(0, 0, 0, frame / 44100, (frame % 44100) * 1000 / 44100);

                //̎Ԃ܂ł̃Cxg`
                while (mh_index < mouse_list.Count && mouse_list[mh_index].time < ts) {
                    mb = mouse_list[mh_index].button;
                    //}EXʒuŃ{[Ǝgݒ
                    vol = (CANVAS_HEIGHT - mouse_list[mh_index].y)*30;
                    delta_phase = (100 + mouse_list[mh_index].x * 4) / 44100f;
                    mh_index++;
                }

                phase += delta_phase;
                if(phase>1.0f) phase -= (int)phase;
                if ((mb & MouseButtons.Left) > 0) {
                    //`g
                    buffer[pos] += (short)(phase > 0.5f ? vol : -vol);
                }
                if ((mb & MouseButtons.Right) > 0) {
                    //sing
                    buffer[pos] += (short)(vol * Math.Sin(phase * 2 * Math.PI));
                }
                if ((mb & MouseButtons.Middle) > 0) {
                    //Opg
                    if (phase < 0.25) buffer[pos] += (short)(phase / 4 * vol);
                    else if (phase < 0.75) buffer[pos] += (short)((0.5f - phase) / 4 * vol);
                    else buffer[pos] += (short)((phase - 1.0f) / 4 * vol);
                }

                //XeIȂ̂ōERs[
                buffer[pos + 1] = buffer[pos];


                //1bɕۑ
                if (frame % 44100 == 44099) {
                    am.AddAudioFrame(buffer);
                    cmdStart.Text = String.Format("ۑcF{0}bI", (frame + 1) / 44100);
                    Application.DoEvents();
                }

            }

            am.Close();
            MessageBox.Show(FileName + "ɓ𐶐܂B");

        }


        void DrawPreview(MouseHistory mh, Graphics g) {
            //{^̏ԂɉĊG`

            if ((mh.button & MouseButtons.Left) > 0) {
                //Ă~
                g.FillEllipse(new SolidBrush(mh.col), mh.x - 6, mh.y - 6, 12, 12);
            }
            if ((mh.button & MouseButtons.Right) > 0) {
                //EĂ牡lp
                g.FillRectangle(new SolidBrush(mh.col), mh.x - 10, mh.y - 3, 20, 6);
            }
            if ((mh.button & MouseButtons.Middle) > 0) {
                //^񒆂Ăclp
                g.FillRectangle(new SolidBrush(mh.col), mh.x - 3, mh.y - 10, 6, 20);
            }


        }


        //}EX̗
        private void AddMouseHistory(MouseEventArgs e) {

            if (Recording == RecordingStatus.WAIT_START && e.Button != 0) {
                //Jn㏉߂ă}EXƊJn
                InitializeRecord();
            }

            if (Recording == RecordingStatus.RECORDING) {

                if (e.X < -5 || e.Y < -5 || e.X > CANVAS_WIDTH + 5 || e.Y > CANVAS_HEIGHT + 5)
                    return;
                
                //L^
                int count = mouse_list.Count;
                MouseHistory mh = new MouseHistory();
                mh.button = e.Button;
                mh.x = e.X;
                mh.y = e.Y;
                mh.time = DateTime.Now - StartTime;

                Random r = new Random();
                mh.col = Color.FromArgb(count % 256, count * 2 % 256, 255 - count / 2 % 256);

                mouse_list.Add(mh);

                DrawPreview(mh, bb_g);
                picCanvas.CreateGraphics().DrawImage(bb_bmp, 0, 0);
            }
            //^撆łȂΉȂ

        }

        private void picCanvas_MouseDown(object sender, MouseEventArgs e) {
            //mousemoveEmouseupƋpA}EXEE
            AddMouseHistory(e);
        }


        private void MainForm_Load(object sender, EventArgs e) {
            //obNGhpBMP쐬
            bb_bmp = new Bitmap(CANVAS_WIDTH, CANVAS_HEIGHT);
            bb_g = Graphics.FromImage(bb_bmp);
        }

        private void btnStart_Click(object sender, EventArgs e) {
            if (Recording == RecordingStatus.STOP) {
                cmdStart.Text = "`߂Ă";
                cmdStart.Enabled = false;
                Recording = RecordingStatus.WAIT_START;
            }
        }

        private void timer1_Tick(object sender, EventArgs e) {
            TimeSpan ts = DateTime.Now - StartTime;
            //Ԍo߂̃JEg

            if (ts.Seconds >= RECORD_TIME) {
                //I
                Recording = RecordingStatus.PROCESSING;
                timer1.Enabled = false;
                cmdStart.Text = "ۑc";
                Application.DoEvents();

                SaveMovie();


                cmdStart.Text = "^Jn";
                cmdStart.Enabled = true;
                Recording = RecordingStatus.STOP;
            }
            else {
                //i\
                toolStripProgressBar1.Value = (int)(toolStripProgressBar1.Maximum * ts.TotalSeconds / RECORD_TIME);
            }
        }
    }
}